diff --git src/test/com/cloudera/sqoop/TestAllTables.java src/test/com/cloudera/sqoop/TestAllTables.java
index 4d5c33c..5eccb77 100644
--- src/test/com/cloudera/sqoop/TestAllTables.java
+++ src/test/com/cloudera/sqoop/TestAllTables.java
@@ -18,17 +18,17 @@
 
 package com.cloudera.sqoop;
 
-import java.io.BufferedReader;
-import java.io.File;
-import java.io.FileInputStream;
-import java.io.IOException;
-import java.io.InputStreamReader;
+import java.io.*;
 import java.sql.SQLException;
 import java.util.ArrayList;
+import java.util.Arrays;
 import java.util.List;
 
+import org.apache.hadoop.fs.FSDataInputStream;
+import org.apache.hadoop.fs.FileSystem;
 import org.apache.hadoop.fs.Path;
 import org.apache.hadoop.io.IOUtils;
+import org.junit.After;
 import org.junit.Before;
 
 import com.cloudera.sqoop.testutil.CommonArgs;
@@ -122,9 +122,16 @@ public class TestAllTables extends ImportJobTestCase {
           + this.expectedStrings.get(0);
       this.expectedStrings.remove(0);
 
-      BufferedReader reader = new BufferedReader(
-          new InputStreamReader(new FileInputStream(
-          new File(filePath.toString()))));
+      BufferedReader reader = null;
+      if (!onPhysicalCluster) {
+        reader = new BufferedReader(
+            new InputStreamReader(new FileInputStream(
+                new File(filePath.toString()))));
+      } else {
+        FileSystem dfs = FileSystem.get(getConf());
+        FSDataInputStream dis = dfs.open(filePath);
+        reader = new BufferedReader(new InputStreamReader(dis));
+      }
       try {
         String line = reader.readLine();
         assertEquals("Table " + tableName + " expected a different string",
diff --git src/test/com/cloudera/sqoop/TestAppendUtils.java src/test/com/cloudera/sqoop/TestAppendUtils.java
index 83cd778..4efffb2 100644
--- src/test/com/cloudera/sqoop/TestAppendUtils.java
+++ src/test/com/cloudera/sqoop/TestAppendUtils.java
@@ -269,7 +269,8 @@ public class TestAppendUtils extends ImportJobTestCase {
    */
   public void testAppendSrcDoesNotExist() throws IOException {
     Configuration conf = new Configuration();
-    conf.set("fs.default.name", "file:///");
+    if (!onPhysicalCluster)
+      conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
     SqoopOptions options = new SqoopOptions(conf);
     options.setTableName("meep");
     Path missingPath = new Path("doesNotExistForAnyReason");
diff --git src/test/com/cloudera/sqoop/TestColumnTypes.java src/test/com/cloudera/sqoop/TestColumnTypes.java
index fa7f7ec..3794949 100644
--- src/test/com/cloudera/sqoop/TestColumnTypes.java
+++ src/test/com/cloudera/sqoop/TestColumnTypes.java
@@ -18,6 +18,7 @@
 
 package com.cloudera.sqoop;
 
+import com.cloudera.sqoop.testutil.CommonArgs;
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
 
diff --git src/test/com/cloudera/sqoop/TestExport.java src/test/com/cloudera/sqoop/TestExport.java
index a1df9be..5fccbc3 100644
--- src/test/com/cloudera/sqoop/TestExport.java
+++ src/test/com/cloudera/sqoop/TestExport.java
@@ -32,6 +32,8 @@ import java.sql.SQLException;
 import java.util.ArrayList;
 import java.util.List;
 
+import com.cloudera.sqoop.testutil.BaseSqoopTestCase;
+import com.cloudera.sqoop.testutil.CommonArgs;
 import org.apache.hadoop.conf.Configuration;
 import org.apache.hadoop.fs.FileSystem;
 import org.apache.hadoop.fs.Path;
@@ -152,7 +154,8 @@ public class TestExport extends ExportJobTestCase {
     Path filePath = new Path(tablePath, "part" + fileNum + ext);
 
     Configuration conf = new Configuration();
-    conf.set("fs.default.name", "file:///");
+    if (!BaseSqoopTestCase.onPhysicalCluster)
+      conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
     FileSystem fs = FileSystem.get(conf);
     fs.mkdirs(tablePath);
     OutputStream os = fs.create(filePath);
@@ -176,7 +179,8 @@ public class TestExport extends ExportJobTestCase {
   private void verifyCompressedFile(Path f, int expectedNumLines)
       throws IOException {
     Configuration conf = new Configuration();
-    conf.set("fs.default.name", "file:///");
+    if (!BaseSqoopTestCase.onPhysicalCluster)
+      conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
     FileSystem fs = FileSystem.get(conf);
     InputStream is = fs.open(f);
     CompressionCodecFactory ccf = new CompressionCodecFactory(conf);
@@ -225,7 +229,8 @@ public class TestExport extends ExportJobTestCase {
 
       // Create the SequenceFile.
       Configuration conf = new Configuration();
-      conf.set("fs.default.name", "file:///");
+      if (!BaseSqoopTestCase.onPhysicalCluster)
+        conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
       FileSystem fs = FileSystem.get(conf);
       Path tablePath = getTablePath();
       Path filePath = new Path(tablePath, "part" + fileNum);
@@ -355,7 +360,8 @@ public class TestExport extends ExportJobTestCase {
   /** Removing an existing table directory from the filesystem. */
   private void removeTablePath() throws IOException {
     Configuration conf = new Configuration();
-    conf.set("fs.default.name", "file:///");
+    if (!BaseSqoopTestCase.onPhysicalCluster)
+      conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
     FileSystem fs = FileSystem.get(conf);
     fs.delete(getTablePath(), true);
   }
diff --git src/test/com/cloudera/sqoop/TestExportUpdate.java src/test/com/cloudera/sqoop/TestExportUpdate.java
index 531c539..fc26a9f 100644
--- src/test/com/cloudera/sqoop/TestExportUpdate.java
+++ src/test/com/cloudera/sqoop/TestExportUpdate.java
@@ -27,6 +27,7 @@ import java.sql.PreparedStatement;
 import java.sql.ResultSet;
 import java.sql.SQLException;
 
+import com.cloudera.sqoop.testutil.CommonArgs;
 import org.apache.hadoop.conf.Configuration;
 import org.apache.hadoop.fs.FileSystem;
 import org.apache.hadoop.fs.Path;
@@ -115,8 +116,10 @@ public class TestExportUpdate extends ExportJobTestCase {
    */
   private void createUpdateFiles(int numFiles, int updatesPerFile,
       int keyCol, int... startOffsets) throws IOException {
-
-    FileSystem fs = FileSystem.getLocal(new Configuration());
+    Configuration conf = getConf();
+    if (!onPhysicalCluster)
+      conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
+    FileSystem fs = FileSystem.get(conf);
 
     int rowId = 0;
     for (int i = 0; i < numFiles; i++) {
diff --git src/test/com/cloudera/sqoop/TestMerge.java src/test/com/cloudera/sqoop/TestMerge.java
index 32a0c03..cd941c8 100644
--- src/test/com/cloudera/sqoop/TestMerge.java
+++ src/test/com/cloudera/sqoop/TestMerge.java
@@ -29,6 +29,8 @@ import java.sql.SQLException;
 
 import java.util.List;
 
+import com.cloudera.sqoop.testutil.CommonArgs;
+import com.cloudera.sqoop.testutil.HsqldbTestServer;
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
 import org.apache.hadoop.conf.Configuration;
@@ -50,7 +52,7 @@ import junit.framework.TestCase;
 /**
  * Test that the merge tool works.
  */
-public class TestMerge extends TestCase {
+public class TestMerge extends BaseSqoopTestCase {
 
   private static final Log LOG =
       LogFactory.getLog(TestMerge.class.getName());
@@ -61,42 +63,23 @@ public class TestMerge extends TestCase {
   public static final String SOURCE_DB_URL = "jdbc:hsqldb:mem:merge";
 
   @Override
-  public void setUp() throws IOException, InterruptedException, SQLException {
-    Configuration conf = newConf();
-    SqoopOptions options = getSqoopOptions(conf);
-    manager = new HsqldbManager(options);
-    conn = manager.getConnection();
-  }
-
-  @Override
-  public void tearDown() throws SQLException {
-    if (null != conn) {
-      this.conn.close();
-    }
-  }
-
-  /** Base directory for all temporary data. */
-  public static final String TEMP_BASE_DIR;
-
-  /** Where to import table data to in the local filesystem for testing. */
-  public static final String LOCAL_WAREHOUSE_DIR;
-
-  // Initializer for the above.
-  static {
-    String tmpDir = System.getProperty("test.build.data", "/tmp/");
-    if (!tmpDir.endsWith(File.separator)) {
-      tmpDir = tmpDir + File.separator;
+  public void setUp() {
+    super.setUp();
+    manager = getManager();
+    try {
+      conn = manager.getConnection();
+    } catch (SQLException e) {
+      e.printStackTrace();
+      throw new RuntimeException(e);
     }
-
-    TEMP_BASE_DIR = tmpDir;
-    LOCAL_WAREHOUSE_DIR = TEMP_BASE_DIR + "sqoop/warehouse";
   }
 
-  public static final String TABLE_NAME = "MergeTable"; 
+  public static final String TABLE_NAME = "MergeTable";
 
   public Configuration newConf() {
     Configuration conf = new Configuration();
-    conf.set("fs.default.name", "file:///");
+    if (!BaseSqoopTestCase.onPhysicalCluster)
+      conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
     conf.set("mapred.job.tracker", "local");
     return conf;
   }
@@ -106,7 +89,7 @@ public class TestMerge extends TestCase {
    */
   public SqoopOptions getSqoopOptions(Configuration conf) {
     SqoopOptions options = new SqoopOptions(conf);
-    options.setConnectString(SOURCE_DB_URL);
+    options.setConnectString(HsqldbTestServer.getDbUrl());
 
     return options;
   }
diff --git src/test/com/cloudera/sqoop/TestMultiMaps.java src/test/com/cloudera/sqoop/TestMultiMaps.java
index 3c2da4b..0c822a2 100644
--- src/test/com/cloudera/sqoop/TestMultiMaps.java
+++ src/test/com/cloudera/sqoop/TestMultiMaps.java
@@ -22,6 +22,7 @@ import java.io.IOException;
 import java.util.ArrayList;
 import java.util.List;
 
+import com.cloudera.sqoop.testutil.*;
 import org.apache.commons.cli.ParseException;
 import org.apache.hadoop.conf.Configuration;
 import org.apache.hadoop.fs.FileStatus;
@@ -34,10 +35,6 @@ import org.apache.hadoop.util.ReflectionUtils;
 
 import com.cloudera.sqoop.SqoopOptions.InvalidOptionsException;
 import com.cloudera.sqoop.orm.CompilationManager;
-import com.cloudera.sqoop.testutil.CommonArgs;
-import com.cloudera.sqoop.testutil.HsqldbTestServer;
-import com.cloudera.sqoop.testutil.ImportJobTestCase;
-import com.cloudera.sqoop.testutil.SeqFileReader;
 import com.cloudera.sqoop.tool.ImportTool;
 import com.cloudera.sqoop.util.ClassLoaderStack;
 
@@ -89,7 +86,8 @@ public class TestMultiMaps extends ImportJobTestCase {
   protected List<Path> getDataFilePaths() throws IOException {
     List<Path> paths = new ArrayList<Path>();
     Configuration conf = new Configuration();
-    conf.set("fs.default.name", "file:///");
+    if (!BaseSqoopTestCase.onPhysicalCluster)
+      conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
     FileSystem fs = FileSystem.get(conf);
 
     FileStatus [] stats = fs.listStatus(getTablePath(),
diff --git src/test/com/cloudera/sqoop/lib/TestBlobRef.java src/test/com/cloudera/sqoop/lib/TestBlobRef.java
index c435353..69aa837 100644
--- src/test/com/cloudera/sqoop/lib/TestBlobRef.java
+++ src/test/com/cloudera/sqoop/lib/TestBlobRef.java
@@ -20,6 +20,8 @@ package com.cloudera.sqoop.lib;
 
 import java.io.*;
 
+import com.cloudera.sqoop.testutil.BaseSqoopTestCase;
+import com.cloudera.sqoop.testutil.CommonArgs;
 import junit.framework.TestCase;
 
 import org.apache.hadoop.conf.Configuration;
@@ -94,7 +96,8 @@ public class TestBlobRef extends TestCase {
       throws IOException {
 
     Configuration conf = new Configuration();
-    conf.set("fs.defaultFS", "file:///");
+    if (!BaseSqoopTestCase.onPhysicalCluster)
+      conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
     FileSystem fs = FileSystem.get(conf);
     String tmpDir = System.getProperty("test.build.data", "/tmp/");
 
diff --git src/test/com/cloudera/sqoop/lib/TestClobRef.java src/test/com/cloudera/sqoop/lib/TestClobRef.java
index 28a9347..b0657a3 100644
--- src/test/com/cloudera/sqoop/lib/TestClobRef.java
+++ src/test/com/cloudera/sqoop/lib/TestClobRef.java
@@ -20,6 +20,8 @@ package com.cloudera.sqoop.lib;
 
 import java.io.*;
 
+import com.cloudera.sqoop.testutil.BaseSqoopTestCase;
+import com.cloudera.sqoop.testutil.CommonArgs;
 import junit.framework.TestCase;
 
 import org.apache.hadoop.conf.Configuration;
@@ -108,7 +110,8 @@ public class TestClobRef extends TestCase {
       throws IOException {
 
     Configuration conf = new Configuration();
-    conf.set("fs.defaultFS", "file:///");
+    if (!BaseSqoopTestCase.onPhysicalCluster)
+      conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
     FileSystem fs = FileSystem.get(conf);
     String tmpDir = System.getProperty("test.build.data", "/tmp/");
 
diff --git src/test/com/cloudera/sqoop/lib/TestLargeObjectLoader.java src/test/com/cloudera/sqoop/lib/TestLargeObjectLoader.java
index a7f299c..ac1b069 100644
--- src/test/com/cloudera/sqoop/lib/TestLargeObjectLoader.java
+++ src/test/com/cloudera/sqoop/lib/TestLargeObjectLoader.java
@@ -24,6 +24,8 @@ import java.io.Reader;
 import java.sql.ResultSet;
 import java.sql.SQLException;
 
+import com.cloudera.sqoop.testutil.BaseSqoopTestCase;
+import com.cloudera.sqoop.testutil.CommonArgs;
 import junit.framework.TestCase;
 
 import org.apache.hadoop.conf.Configuration;
@@ -47,10 +49,12 @@ public class TestLargeObjectLoader extends TestCase {
 
   public void setUp() throws IOException, InterruptedException {
     conf = new Configuration();
-    conf.set("fs.defaultFS", "file:///");
+    if (!BaseSqoopTestCase.onPhysicalCluster)
+      conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
+
     String tmpDir = System.getProperty("test.build.data", "/tmp/");
     this.outDir = new Path(new Path(tmpDir), "testLobLoader");
-    FileSystem fs = FileSystem.getLocal(conf);
+    FileSystem fs = FileSystem.get(conf);
     if (fs.exists(outDir)) {
       fs.delete(outDir, true);
     }
diff --git src/test/com/cloudera/sqoop/orm/TestParseMethods.java src/test/com/cloudera/sqoop/orm/TestParseMethods.java
index acef388..8f4008e 100644
--- src/test/com/cloudera/sqoop/orm/TestParseMethods.java
+++ src/test/com/cloudera/sqoop/orm/TestParseMethods.java
@@ -21,6 +21,7 @@ package com.cloudera.sqoop.orm;
 import java.io.IOException;
 import java.util.ArrayList;
 
+import com.cloudera.sqoop.testutil.*;
 import org.apache.commons.cli.ParseException;
 import org.apache.hadoop.fs.Path;
 import org.apache.hadoop.io.NullWritable;
@@ -33,10 +34,6 @@ import org.apache.hadoop.mapred.JobConf;
 import com.cloudera.sqoop.SqoopOptions;
 import com.cloudera.sqoop.SqoopOptions.InvalidOptionsException;
 import com.cloudera.sqoop.config.ConfigurationHelper;
-import com.cloudera.sqoop.testutil.CommonArgs;
-import com.cloudera.sqoop.testutil.HsqldbTestServer;
-import com.cloudera.sqoop.testutil.ImportJobTestCase;
-import com.cloudera.sqoop.testutil.ReparseMapper;
 import com.cloudera.sqoop.tool.ImportTool;
 import com.cloudera.sqoop.util.ClassLoaderStack;
 
@@ -119,7 +116,8 @@ public class TestParseMethods extends ImportJobTestCase {
 
       // use local mode in the same JVM.
       ConfigurationHelper.setJobtrackerAddr(job, "local");
-      job.set("fs.default.name", "file:///");
+      if (!BaseSqoopTestCase.onPhysicalCluster)
+        job.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
 
       String warehouseDir = getWarehouseDir();
       Path warehousePath = new Path(warehouseDir);
diff --git src/test/com/cloudera/sqoop/testutil/BaseSqoopTestCase.java src/test/com/cloudera/sqoop/testutil/BaseSqoopTestCase.java
index f6d2474..e98a988 100644
--- src/test/com/cloudera/sqoop/testutil/BaseSqoopTestCase.java
+++ src/test/com/cloudera/sqoop/testutil/BaseSqoopTestCase.java
@@ -29,6 +29,7 @@ import java.util.Arrays;
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
 import org.apache.hadoop.conf.Configuration;
+import org.apache.hadoop.fs.FileSystem;
 import org.apache.hadoop.fs.Path;
 import org.apache.hadoop.util.StringUtils;
 import org.apache.log4j.BasicConfigurator;
@@ -50,6 +51,7 @@ public class BaseSqoopTestCase extends TestCase {
 
   public static final Log LOG = LogFactory.getLog(
       BaseSqoopTestCase.class.getName());
+  public static boolean onPhysicalCluster = false;
 
   /** Base directory for all temporary data. */
   public static final String TEMP_BASE_DIR;
@@ -166,7 +168,10 @@ public class BaseSqoopTestCase extends TestCase {
 
   @Before
   public void setUp() {
-
+    // The assumption is that correct HADOOP configuration will have it set to
+    // hdfs://namenode
+    onPhysicalCluster =
+        !CommonArgs.LOCAL_FS.equals(System.getProperty(CommonArgs.FS_DEFAULT_NAME));
     incrementTableNum();
 
     if (!isLog4jConfigured) {
@@ -205,6 +210,20 @@ public class BaseSqoopTestCase extends TestCase {
     }
   }
 
+  private void guaranteeCleanWarehouse() {
+    if (onPhysicalCluster) {
+      Path warehousePath = new Path(this.getWarehouseDir());
+      try {
+        FileSystem fs = FileSystem.get(getConf());
+        fs.delete(warehousePath, true);
+      } catch (IOException e) {
+        LOG.warn(e);
+      }
+    }
+    File s = new File(getWarehouseDir());
+    s.delete();
+  }
+
   @After
   public void tearDown() {
     setCurTableName(null); // clear user-override table name.
@@ -218,6 +237,7 @@ public class BaseSqoopTestCase extends TestCase {
       LOG.error("Got SQLException: " + StringUtils.stringifyException(sqlE));
       fail("Got SQLException: " + StringUtils.stringifyException(sqlE));
     }
+    guaranteeCleanWarehouse();
   }
 
   static final String BASE_COL_NAME = "DATA_COL";
diff --git src/test/com/cloudera/sqoop/testutil/CommonArgs.java src/test/com/cloudera/sqoop/testutil/CommonArgs.java
index aeeba66..36ef7b4 100644
--- src/test/com/cloudera/sqoop/testutil/CommonArgs.java
+++ src/test/com/cloudera/sqoop/testutil/CommonArgs.java
@@ -28,6 +28,16 @@ public final class CommonArgs {
   private CommonArgs() {
   }
 
+  public static String LOCAL_FS="file:///";
+  public static String FS_DEFAULT_NAME="fs.defaultfs.name"; // is deprecated past 0.21
+  public static String FS_DEFAULTFS="fs.defaultFS";
+
+  public static String getJobtrackerAddress () {
+    return System.getProperty("mapreduce.jobtracker.address", "local");
+  }
+  public static String getDefaultFS() {
+    return System.getProperty(FS_DEFAULT_NAME, LOCAL_FS);
+  }
   /**
    * Craft a list of arguments that are common to (virtually)
    * all Sqoop programs.
diff --git src/test/com/cloudera/sqoop/testutil/HsqldbTestServer.java src/test/com/cloudera/sqoop/testutil/HsqldbTestServer.java
index 446ddc2..e20e909 100644
--- src/test/com/cloudera/sqoop/testutil/HsqldbTestServer.java
+++ src/test/com/cloudera/sqoop/testutil/HsqldbTestServer.java
@@ -128,6 +128,14 @@ public class HsqldbTestServer {
   }
 
   /**
+   * Returns database URL for the server instance
+   * @return String representation of DB_URL
+   */
+  public static String getDbUrl() {
+    return DB_URL;
+  }
+
+  /**
    * Create a table.
    */
   public void createSchema() throws SQLException {
diff --git src/test/com/cloudera/sqoop/testutil/ImportJobTestCase.java src/test/com/cloudera/sqoop/testutil/ImportJobTestCase.java
index 5eaf828..1666abf 100644
--- src/test/com/cloudera/sqoop/testutil/ImportJobTestCase.java
+++ src/test/com/cloudera/sqoop/testutil/ImportJobTestCase.java
@@ -148,8 +148,9 @@ public class ImportJobTestCase extends BaseSqoopTestCase {
 
       // Now open and check all part-files in the table path until we find
       // a non-empty one that we can verify contains the value.
-
-      FileSystem fs = FileSystem.getLocal(conf);
+      if (!BaseSqoopTestCase.onPhysicalCluster)
+        conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
+      FileSystem fs = FileSystem.get(conf);
       FileStatus [] stats = fs.listStatus(tableDirPath);
 
       if (stats == null || stats.length == 0) {
diff --git src/test/com/cloudera/sqoop/testutil/SeqFileReader.java src/test/com/cloudera/sqoop/testutil/SeqFileReader.java
index b30ac1b..28a544b 100644
--- src/test/com/cloudera/sqoop/testutil/SeqFileReader.java
+++ src/test/com/cloudera/sqoop/testutil/SeqFileReader.java
@@ -29,6 +29,8 @@ import org.apache.hadoop.io.SequenceFile;
 import org.apache.hadoop.io.SequenceFile.Reader;
 import org.apache.hadoop.util.ReflectionUtils;
 
+import javax.print.attribute.standard.Copies;
+
 /**
  * Utility class to help with test cases. Just reads the first (k, v) pair
  * from a SequenceFile and returns the value part.
@@ -46,7 +48,8 @@ public final class SeqFileReader {
   public static Reader getSeqFileReader(String filename) throws IOException {
     // read from local filesystem
     Configuration conf = new Configuration();
-    conf.set("fs.default.name", "file:///");
+    if (!BaseSqoopTestCase.onPhysicalCluster)
+      conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
     FileSystem fs = FileSystem.get(conf);
     LOG.info("Opening SequenceFile " + filename);
     return new SequenceFile.Reader(fs, new Path(filename), conf);
@@ -57,7 +60,8 @@ public final class SeqFileReader {
     try {
       // read from local filesystem
       Configuration conf = new Configuration();
-      conf.set("fs.default.name", "file:///");
+      if (!BaseSqoopTestCase.onPhysicalCluster)
+        conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
       FileSystem fs = FileSystem.get(conf);
       r = new SequenceFile.Reader(fs, new Path(filename), conf);
       Object key = ReflectionUtils.newInstance(r.getKeyClass(), conf);