From dc462ed2c8c87b0fce6dd1aae8892c17e3a0c88c Mon Sep 17 00:00:00 2001
From: Jonathan hsieh <jon@ubuntu.(none)>
Date: Mon, 11 Apr 2011 18:11:35 -0700
Subject: [PATCH] FLUME-601: Fix Cobertura coverage testing dependencies

---
 build.xml                      |    2 +-
 libtest/asm-3.3.1.jar          |  Bin 0 -> 43579 bytes
 libtest/asm-analysis-3.3.1.jar |  Bin 0 -> 18356 bytes
 libtest/asm-commons-3.3.1.jar  |  Bin 0 -> 38313 bytes
 libtest/asm-tree-3.3.1.jar     |  Bin 0 -> 21505 bytes
 libtest/asm-util-3.3.1.jar     |  Bin 0 -> 36961 bytes
 libtest/asm-xml-3.3.1.jar      |  Bin 0 -> 49636 bytes
 libtest/asm.LICENSE            |   31 +++++++++++++++++++++++++++++++
 libtest/jakarta-oro-2.0.8.jar  |  Bin 0 -> 65425 bytes
 9 files changed, 32 insertions(+), 1 deletions(-)
 create mode 100644 libtest/asm-3.3.1.jar
 create mode 100644 libtest/asm-analysis-3.3.1.jar
 create mode 100644 libtest/asm-commons-3.3.1.jar
 create mode 100644 libtest/asm-tree-3.3.1.jar
 create mode 100644 libtest/asm-util-3.3.1.jar
 create mode 100644 libtest/asm-xml-3.3.1.jar
 create mode 100644 libtest/asm.LICENSE
 create mode 100644 libtest/jakarta-oro-2.0.8.jar

diff --git a/build.xml b/build.xml
index 2b72fb6..4895235 100644
--- a/build.xml
+++ b/build.xml
@@ -562,7 +562,7 @@ to call at top-level: ant deploy-contrib compile-core-test
         errorProperty="tests.failed" failureProperty="tests.failed"
         timeout="${test.timeout}"
         dir="${test.build.dir}">
-      <classpath location="${ivy.tools.lib}/cobertura.jar"/>
+      <classpath location="${ivy.tools.lib}/cobertura-1.9.4.1.jar"/>
       <classpath location="build/instrumented-classes"/>
       
       <!-- uncomment this if you want to attach a debugger -->
diff --git a/libtest/asm-3.3.1.jar b/libtest/asm-3.3.1.jar
new file mode 100644
index 0000000000000000000000000000000000000000..349f0d42bb423a2a90f4186cfbb4b3373c3d8a2d
GIT binary patch
diff --git a/libtest/asm-analysis-3.3.1.jar b/libtest/asm-analysis-3.3.1.jar
new file mode 100644
index 0000000000000000000000000000000000000000..c478b6b5818fcceaba186553210bb7de4cacb806
GIT binary patch
diff --git a/libtest/asm-commons-3.3.1.jar b/libtest/asm-commons-3.3.1.jar
new file mode 100644
index 0000000000000000000000000000000000000000..8a588467b064beac0ea2aba1d7d723168d3e7594
GIT binary patch
diff --git a/libtest/asm-tree-3.3.1.jar b/libtest/asm-tree-3.3.1.jar
new file mode 100644
index 0000000000000000000000000000000000000000..48550be7a42fc1f2d3700bfd3b144bed5e639ec8
GIT binary patch
diff --git a/libtest/asm-util-3.3.1.jar b/libtest/asm-util-3.3.1.jar
new file mode 100644
index 0000000000000000000000000000000000000000..0230bbcfb71bf24e7ac9b49e32a84b7eceaeb5a9
GIT binary patch
diff --git a/libtest/asm-xml-3.3.1.jar b/libtest/asm-xml-3.3.1.jar
new file mode 100644
index 0000000000000000000000000000000000000000..aba5cbdb63ea0c0e7a531284cc627ff47fcd2928
GIT binary patch
diff --git a/libtest/asm.LICENSE b/libtest/asm.LICENSE
new file mode 100644
index 0000000..6e1f9ac
--- /dev/null
+++ b/libtest/asm.LICENSE
@@ -0,0 +1,31 @@
+http://asm.ow2.org/license.html
+
+Copyright (c) 2000-2005 INRIA, France Telecom
+All rights reserved.
+
+Redistribution and use in source and binary forms, with or without
+modification, are permitted provided that the following conditions
+are met:
+
+1. Redistributions of source code must retain the above copyright
+   notice, this list of conditions and the following disclaimer.
+
+2. Redistributions in binary form must reproduce the above copyright
+   notice, this list of conditions and the following disclaimer in the
+   documentation and/or other materials provided with the distribution.
+
+3. Neither the name of the copyright holders nor the names of its
+   contributors may be used to endorse or promote products derived from
+   this software without specific prior written permission.
+
+THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+THE POSSIBILITY OF SUCH DAMAGE.
\ No newline at end of file
diff --git a/libtest/jakarta-oro-2.0.8.jar b/libtest/jakarta-oro-2.0.8.jar
new file mode 100644
index 0000000000000000000000000000000000000000..ed6c60a6fde5e04442af1ca3edfd5bc8533dd96e
GIT binary patch
-- 
1.7.1